#define GPS_ID     "Prolific"    // HGPS
#define GPS_BAUD   38400         // ʐMx(bps)

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "comchk.h"
#include "rs232_dll.h"

double dms_conv(double degree_minute)
{
	double d,min;
	d = (int)degree_minute;
	min = ( degree_minute - d ) * 100;
	d = d + min/60;
	return d;
}

int gps_lat_lng_read(double *gps_lat,double *gps_lng)
{
	int i,n,st,flag,nn;
	int PortNum,BaudNum;
	double lat,lng,t;
	double declination;
	unsigned char buf[256],tmp[256];
	char s1,s2;
	
	// find GPS com_port
	port_device_scan();
	port_device_pickup(GPS_ID);
	n = get_how_many_port_devices();
	if (n==0) {
		//printf("Error: GPS com_port not found.\n");
		return -1; // error
	}
	PortNum = get_port_number(0);
	BaudNum = GPS_BAUD;
	//printf("com_port=%d , baud_rate=%d\n",PortNum,BaudNum);
	
	// com port open
	st = rs_open(PortNum,BaudNum);
	if (st == -1) {
		//printf("Error: COM%i cannot open.\n",PortNum);
		return -1; // error
	}
	
	// read GPS
	while (1) {
		if (rs_size(PortNum)) { // data exist in serial buffer?
			rs_gets(PortNum,(unsigned char *)buf);
			if (buf[0]!='$') { continue; }
			if ((buf[1]=='G')&&(buf[2]=='P')&&(buf[3]=='G')&&(buf[4]=='G')&&(buf[5]=='A')) {
				printf("GPS Raw log: <%s>\n",buf);
				nn=sscanf((char *)buf+7,"%lf,%lf,%c,%lf,%c,%d",&t,&lat,&s1,&lng,&s2,&flag);
				if (nn!=6) { // error
					//printf("Warning: GPS data error.\n");
					return -1;
				} else {
					lat=lat/100; lng=lng/100;
					lat=dms_conv(lat); lng=dms_conv(lng);
					if (s1=='S') { lat= -lat; }
					if (s2=='W') { lng= -lng; }
					break;
				}
				break;
			}
		}
	}
	rs_close(PortNum);
	//if (flag==0) { printf("Warning: GPS cannot get current location now.\n"); }
	//printf("\n");
	//printf("Result: lat=%.6f,lng=%.6f\n",lat,lng);
	
	*gps_lat = lat;
	*gps_lng = lng;
	return 0;
}
